// Copyright 2016 Orus.io. All rights reserved.

package sql

import (
	"testing"

	"bitbucket.org/orus-io/xbus/storage"
	"bitbucket.org/orus-io/xbus/testutils"
	"bitbucket.org/orus-io/xbus/testutils/sqldb"
	storagetest "bitbucket.org/orus-io/xbus/testutils/storage"
)

func jobStorageFactory(tb testing.TB) (storage.JobStorage, func()) {
	testDB := sqldb.GetTestDB(tb)
	if testDB == nil {
		return nil, nil
	}
	m, db := testDB.GetModelDB(1)

	return NewJobStorage(m, db, testutils.GetTestLogger(tb)), func() {
		db.Close()
		testDB.Close()
	}
}

func TestJobStorage(t *testing.T) {
	storagetest.JobStorageTests(t, jobStorageFactory)
}
