package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// GraphName is the Name field name
	GraphName = "Name"
	// GraphNameColumnName is the Name field associated column name
	GraphNameColumnName = "name"
	// GraphVersion is the Version field name
	GraphVersion = "Version"
	// GraphVersionColumnName is the Version field associated column name
	GraphVersionColumnName = "version"
	// GraphStatus is the Status field name
	GraphStatus = "Status"
	// GraphStatusColumnName is the Status field associated column name
	GraphStatusColumnName = "status"
	// GraphEdges is the Edges field name
	GraphEdges = "Edges"
	// GraphEdgesColumnName is the Edges field associated column name
	GraphEdgesColumnName = "edges"
)

const (
	// GraphTableName is the Graph associated table name
	GraphTableName = "graph"
)

var graphTable = qb.Table(
	GraphTableName,
	qb.Column(GraphNameColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphVersionColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphEdgesColumnName, qb.Text()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
	qb.UniqueKey(
		GraphNameColumnName,
		GraphVersionColumnName,
	),
)

var graphType = reflect.TypeOf(Graph{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Graph) StructType() reflect.Type {
	return graphType
}

// GraphModel provides direct access to helpers for Graph
// queries
type GraphModel struct {
	mapper    *GraphMapper
	Name      yago.ScalarField
	Version   yago.ScalarField
	Status    yago.MarshaledScalarField
	Edges     yago.ScalarField
	ID        yago.ScalarField
	CreatedAt yago.ScalarField
	UpdatedAt yago.ScalarField
}

// NewGraphModel returns a new GraphModel
func NewGraphModel(meta *yago.Metadata) GraphModel {
	mapper := NewGraphMapper()
	meta.AddMapper(mapper)
	return GraphModel{
		mapper:    mapper,
		Name:      yago.NewScalarField(mapper.Table().C(GraphNameColumnName)),
		Version:   yago.NewScalarField(mapper.Table().C(GraphVersionColumnName)),
		Status:    yago.NewMarshaledScalarField(mapper.Table().C(GraphStatusColumnName)),
		Edges:     yago.NewScalarField(mapper.Table().C(GraphEdgesColumnName)),
		ID:        yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt: yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt: yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated GraphMapper instance
func (m GraphModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewGraphMapper initialize a NewGraphMapper
func NewGraphMapper() *GraphMapper {
	m := &GraphMapper{}
	return m
}

// GraphMapper is the Graph mapper
type GraphMapper struct{}

// GetMapper returns itself
func (mapper *GraphMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*GraphMapper) Name() string {
	return "model/Graph"
}

// Table returns the mapper table
func (*GraphMapper) Table() *qb.TableElem {
	return &graphTable
}

// StructType returns the reflect.Type of the mapped structure
func (GraphMapper) StructType() reflect.Type {
	return graphType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper GraphMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Graph)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Graph{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, GraphName) {
		m[GraphNameColumnName] = s.Name
	}
	if allValues || yago.StringListContains(fields, GraphVersion) {
		m[GraphVersionColumnName] = s.Version
	}
	if allValues || yago.StringListContains(fields, GraphStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[GraphStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, GraphEdges) {
		m[GraphEdgesColumnName] = s.Edges
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper GraphMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		graphTable.C(GraphNameColumnName),
		graphTable.C(GraphVersionColumnName),
		graphTable.C(GraphStatusColumnName),
		graphTable.C(GraphEdgesColumnName),
		graphTable.C(BaseIDColumnName),
		graphTable.C(BaseCreatedAtColumnName),
		graphTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper GraphMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Graph)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Graph{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper GraphMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Graph)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Graph{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	if err := rows.Scan(
		&s.Name,
		&s.Version,
		&StatusText,
		&s.Edges,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (GraphMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (GraphMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Graph has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper GraphMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Graph)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper GraphMapper) PKeyClause(values []interface{}) qb.Clause {
	return graphTable.C(BaseIDColumnName).Eq(values[0])
}

const (
	// GraphNodeID is the ID field name
	GraphNodeID = "ID"
	// GraphNodeIDColumnName is the ID field associated column name
	GraphNodeIDColumnName = "id"
	// GraphNodeGraphID is the GraphID field name
	GraphNodeGraphID = "GraphID"
	// GraphNodeGraphIDColumnName is the GraphID field associated column name
	GraphNodeGraphIDColumnName = "graph_id"
	// GraphNodeNodeID is the NodeID field name
	GraphNodeNodeID = "NodeID"
	// GraphNodeNodeIDColumnName is the NodeID field associated column name
	GraphNodeNodeIDColumnName = "node_id"
	// GraphNodeType is the Type field name
	GraphNodeType = "Type"
	// GraphNodeTypeColumnName is the Type field associated column name
	GraphNodeTypeColumnName = "type"
	// GraphNodeActorIDs is the ActorIDs field name
	GraphNodeActorIDs = "ActorIDs"
	// GraphNodeActorIDsColumnName is the ActorIDs field associated column name
	GraphNodeActorIDsColumnName = "actor_ids"
	// GraphNodeActors is the Actors field name
	GraphNodeActors = "Actors"
	// GraphNodeActorsColumnName is the Actors field associated column name
	GraphNodeActorsColumnName = "actors"
	// GraphNodeRoles is the Roles field name
	GraphNodeRoles = "Roles"
	// GraphNodeRolesColumnName is the Roles field associated column name
	GraphNodeRolesColumnName = "roles"
	// GraphNodeRoleBroadcast is the RoleBroadcast field name
	GraphNodeRoleBroadcast = "RoleBroadcast"
	// GraphNodeRoleBroadcastColumnName is the RoleBroadcast field associated column name
	GraphNodeRoleBroadcastColumnName = "role_broadcast"
	// GraphNodeSourceMatchEventTypes is the SourceMatchEventTypes field name
	GraphNodeSourceMatchEventTypes = "SourceMatchEventTypes"
	// GraphNodeSourceMatchEventTypesColumnName is the SourceMatchEventTypes field associated column name
	GraphNodeSourceMatchEventTypesColumnName = "source_match_event_types"
	// GraphNodeInputs is the Inputs field name
	GraphNodeInputs = "Inputs"
	// GraphNodeInputsColumnName is the Inputs field associated column name
	GraphNodeInputsColumnName = "inputs"
	// GraphNodeOutputs is the Outputs field name
	GraphNodeOutputs = "Outputs"
	// GraphNodeOutputsColumnName is the Outputs field associated column name
	GraphNodeOutputsColumnName = "outputs"
)

const (
	// GraphNodeTableName is the GraphNode associated table name
	GraphNodeTableName = "graph_node"
)

var graphNodeTable = qb.Table(
	GraphNodeTableName,
	qb.Column(GraphNodeIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(GraphNodeGraphIDColumnName, qb.UUID()).NotNull(),
	qb.Column(GraphNodeNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeTypeColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeActorIDsColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeActorsColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeRolesColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeRoleBroadcastColumnName, qb.Boolean()).NotNull(),
	qb.Column(GraphNodeSourceMatchEventTypesColumnName, qb.Varchar()).NotNull(),
	qb.Column(GraphNodeInputsColumnName, qb.Text()).NotNull(),
	qb.Column(GraphNodeOutputsColumnName, qb.Text()).NotNull(),
	qb.UniqueKey(
		GraphNodeGraphIDColumnName,
		GraphNodeNodeIDColumnName,
	),
	qb.ForeignKey(GraphNodeGraphIDColumnName).References(GraphTableName, BaseIDColumnName),
)

var graphNodeType = reflect.TypeOf(GraphNode{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (GraphNode) StructType() reflect.Type {
	return graphNodeType
}

// GraphNodeModel provides direct access to helpers for GraphNode
// queries
type GraphNodeModel struct {
	mapper                *GraphNodeMapper
	ID                    yago.ScalarField
	GraphID               yago.ScalarField
	NodeID                yago.ScalarField
	Type                  yago.ScalarField
	ActorIDs              yago.ScalarField
	Actors                yago.ScalarField
	Roles                 yago.ScalarField
	RoleBroadcast         yago.ScalarField
	SourceMatchEventTypes yago.ScalarField
	Inputs                yago.ScalarField
	Outputs               yago.ScalarField
}

// NewGraphNodeModel returns a new GraphNodeModel
func NewGraphNodeModel(meta *yago.Metadata) GraphNodeModel {
	mapper := NewGraphNodeMapper()
	meta.AddMapper(mapper)
	return GraphNodeModel{
		mapper:                mapper,
		ID:                    yago.NewScalarField(mapper.Table().C(GraphNodeIDColumnName)),
		GraphID:               yago.NewScalarField(mapper.Table().C(GraphNodeGraphIDColumnName)),
		NodeID:                yago.NewScalarField(mapper.Table().C(GraphNodeNodeIDColumnName)),
		Type:                  yago.NewScalarField(mapper.Table().C(GraphNodeTypeColumnName)),
		ActorIDs:              yago.NewScalarField(mapper.Table().C(GraphNodeActorIDsColumnName)),
		Actors:                yago.NewScalarField(mapper.Table().C(GraphNodeActorsColumnName)),
		Roles:                 yago.NewScalarField(mapper.Table().C(GraphNodeRolesColumnName)),
		RoleBroadcast:         yago.NewScalarField(mapper.Table().C(GraphNodeRoleBroadcastColumnName)),
		SourceMatchEventTypes: yago.NewScalarField(mapper.Table().C(GraphNodeSourceMatchEventTypesColumnName)),
		Inputs:                yago.NewScalarField(mapper.Table().C(GraphNodeInputsColumnName)),
		Outputs:               yago.NewScalarField(mapper.Table().C(GraphNodeOutputsColumnName)),
	}
}

// GetMapper returns the associated GraphNodeMapper instance
func (m GraphNodeModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewGraphNodeMapper initialize a NewGraphNodeMapper
func NewGraphNodeMapper() *GraphNodeMapper {
	m := &GraphNodeMapper{}
	return m
}

// GraphNodeMapper is the GraphNode mapper
type GraphNodeMapper struct{}

// GetMapper returns itself
func (mapper *GraphNodeMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*GraphNodeMapper) Name() string {
	return "model/GraphNode"
}

// Table returns the mapper table
func (*GraphNodeMapper) Table() *qb.TableElem {
	return &graphNodeTable
}

// StructType returns the reflect.Type of the mapped structure
func (GraphNodeMapper) StructType() reflect.Type {
	return graphNodeType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper GraphNodeMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[GraphNodeIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, GraphNodeGraphID) {
		m[GraphNodeGraphIDColumnName] = s.GraphID
	}
	if allValues || yago.StringListContains(fields, GraphNodeNodeID) {
		m[GraphNodeNodeIDColumnName] = s.NodeID
	}
	if allValues || yago.StringListContains(fields, GraphNodeType) {
		m[GraphNodeTypeColumnName] = s.Type
	}
	if allValues || yago.StringListContains(fields, GraphNodeActorIDs) {
		m[GraphNodeActorIDsColumnName] = s.ActorIDs
	}
	if allValues || yago.StringListContains(fields, GraphNodeActors) {
		m[GraphNodeActorsColumnName] = s.Actors
	}
	if allValues || yago.StringListContains(fields, GraphNodeRoles) {
		m[GraphNodeRolesColumnName] = s.Roles
	}
	if allValues || yago.StringListContains(fields, GraphNodeRoleBroadcast) {
		m[GraphNodeRoleBroadcastColumnName] = s.RoleBroadcast
	}
	if allValues || yago.StringListContains(fields, GraphNodeSourceMatchEventTypes) {
		m[GraphNodeSourceMatchEventTypesColumnName] = s.SourceMatchEventTypes
	}
	if allValues || yago.StringListContains(fields, GraphNodeInputs) {
		m[GraphNodeInputsColumnName] = s.Inputs
	}
	if allValues || yago.StringListContains(fields, GraphNodeOutputs) {
		m[GraphNodeOutputsColumnName] = s.Outputs
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper GraphNodeMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		graphNodeTable.C(GraphNodeIDColumnName),
		graphNodeTable.C(GraphNodeGraphIDColumnName),
		graphNodeTable.C(GraphNodeNodeIDColumnName),
		graphNodeTable.C(GraphNodeTypeColumnName),
		graphNodeTable.C(GraphNodeActorIDsColumnName),
		graphNodeTable.C(GraphNodeActorsColumnName),
		graphNodeTable.C(GraphNodeRolesColumnName),
		graphNodeTable.C(GraphNodeRoleBroadcastColumnName),
		graphNodeTable.C(GraphNodeSourceMatchEventTypesColumnName),
		graphNodeTable.C(GraphNodeInputsColumnName),
		graphNodeTable.C(GraphNodeOutputsColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper GraphNodeMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper GraphNodeMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*GraphNode)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &GraphNode{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.GraphID,
		&s.NodeID,
		&s.Type,
		&s.ActorIDs,
		&s.Actors,
		&s.Roles,
		&s.RoleBroadcast,
		&s.SourceMatchEventTypes,
		&s.Inputs,
		&s.Outputs,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (GraphNodeMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (GraphNodeMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*GraphNode)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper GraphNodeMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*GraphNode)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper GraphNodeMapper) PKeyClause(values []interface{}) qb.Clause {
	return graphNodeTable.C(GraphNodeIDColumnName).Eq(values[0])
}
