// Copyright 2018 Orus.io. All rights reserved.

package model

import (
	"github.com/m4rw3r/uuid"

	"bitbucket.org/orus-io/go-xbus/api"
)

//go:generate yago --fmt

// Job stores the directors jobs
//yago:autoattrs
type Job struct {
	ID        int64     `yago:"primary_key,auto_increment"`
	ProcessID uuid.UUID `yago:"unique_index=id"`
	ActorID   uuid.UUID `yago:"unique_index=id"`
	NodeID    string    `yago:"unique_index=id"`

	Detached bool
	Status   api.ActorProcessingState_Status `yago:"textmarshaled"`
}
