package api

import (
	"errors"
	"strings"
	"fmt"
)

// MarshalText serialize a Actor_Kind
func (e Actor_Kind) MarshalText() ([]byte, error) {
	s, ok := Actor_Kind_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Actor_Kind value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Actor_Kind string
func (e *Actor_Kind) UnmarshalText(data []byte) error {
	value, ok := Actor_Kind_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Actor_Kind: " + string(data))
	}
	*e = Actor_Kind(value)
	return nil
}

// MarshalText serialize a Actor_Status
func (e Actor_Status) MarshalText() ([]byte, error) {
	s, ok := Actor_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Actor_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Actor_Status string
func (e *Actor_Status) UnmarshalText(data []byte) error {
	value, ok := Actor_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Actor_Status: " + string(data))
	}
	*e = Actor_Status(value)
	return nil
}

// MarshalText serialize a ActorProcessingState_Status
func (e ActorProcessingState_Status) MarshalText() ([]byte, error) {
	s, ok := ActorProcessingState_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid ActorProcessingState_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a ActorProcessingState_Status string
func (e *ActorProcessingState_Status) UnmarshalText(data []byte) error {
	value, ok := ActorProcessingState_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid ActorProcessingState_Status: " + string(data))
	}
	*e = ActorProcessingState_Status(value)
	return nil
}

// MarshalText serialize a LogLevel
func (e LogLevel) MarshalText() ([]byte, error) {
	s, ok := LogLevel_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid LogLevel value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a LogLevel string
func (e *LogLevel) UnmarshalText(data []byte) error {
	value, ok := LogLevel_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid LogLevel: " + string(data))
	}
	*e = LogLevel(value)
	return nil
}

// MarshalText serialize a Account_Type
func (e Account_Type) MarshalText() ([]byte, error) {
	s, ok := Account_Type_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Account_Type value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Account_Type string
func (e *Account_Type) UnmarshalText(data []byte) error {
	value, ok := Account_Type_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Account_Type: " + string(data))
	}
	*e = Account_Type(value)
	return nil
}

// MarshalText serialize a Account_Status
func (e Account_Status) MarshalText() ([]byte, error) {
	s, ok := Account_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Account_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Account_Status string
func (e *Account_Status) UnmarshalText(data []byte) error {
	value, ok := Account_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Account_Status: " + string(data))
	}
	*e = Account_Status(value)
	return nil
}

// MarshalText serialize a GraphInfo_Status
func (e GraphInfo_Status) MarshalText() ([]byte, error) {
	s, ok := GraphInfo_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid GraphInfo_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a GraphInfo_Status string
func (e *GraphInfo_Status) UnmarshalText(data []byte) error {
	value, ok := GraphInfo_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid GraphInfo_Status: " + string(data))
	}
	*e = GraphInfo_Status(value)
	return nil
}

// MarshalText serialize a Process_Status
func (e Process_Status) MarshalText() ([]byte, error) {
	s, ok := Process_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Process_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Process_Status string
func (e *Process_Status) UnmarshalText(data []byte) error {
	value, ok := Process_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Process_Status: " + string(data))
	}
	*e = Process_Status(value)
	return nil
}

// MarshalText serialize a PMProcess_Status
func (e PMProcess_Status) MarshalText() ([]byte, error) {
	s, ok := PMProcess_Status_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid PMProcess_Status value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a PMProcess_Status string
func (e *PMProcess_Status) UnmarshalText(data []byte) error {
	value, ok := PMProcess_Status_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid PMProcess_Status: " + string(data))
	}
	*e = PMProcess_Status(value)
	return nil
}

// MarshalText serialize a Account_CSROrigin
func (e Account_CSROrigin) MarshalText() ([]byte, error) {
	s, ok := Account_CSROrigin_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid Account_CSROrigin value: %v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a Account_CSROrigin string
func (e *Account_CSROrigin) UnmarshalText(data []byte) error {
	value, ok := Account_CSROrigin_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid Account_CSROrigin: " + string(data))
	}
	*e = Account_CSROrigin(value)
	return nil
}

